VERSION 5.00
Begin VB.Form frmConflicts 
   Caption         =   "Resolve Conflicts"
   ClientHeight    =   1995
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1995
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraProgram 
      Caption         =   "Compare with:"
      Height          =   855
      Left            =   3240
      TabIndex        =   4
      Top             =   120
      Width           =   1335
      Begin VB.OptionButton optProgram 
         Caption         =   "WinDiff"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   6
         Top             =   480
         Value           =   -1  'True
         Width           =   1095
      End
      Begin VB.OptionButton optProgram 
         Caption         =   "FC (DOS)"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1380
      Width           =   1215
   End
   Begin VB.CommandButton cmdCompare 
      Caption         =   "Compare"
      Enabled         =   0   'False
      Height          =   495
      Left            =   3060
      TabIndex        =   2
      Top             =   1380
      Width           =   1515
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Edit"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1440
      TabIndex        =   1
      Top             =   1380
      Width           =   1515
   End
   Begin VB.ListBox lstConflicts 
      Height          =   1230
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   48
      Width           =   3015
   End
End
Attribute VB_Name = "frmConflicts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'find Windows version API functions
Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2

Private Type OSVERSIONINFO
  OSVSize         As Long         'size, in bytes, of this data structure
  dwVerMajor      As Long         'ie NT 3.51, dwVerMajor = 3; NT 4.0, dwVerMajor = 4.
  dwVerMinor      As Long         'ie NT 3.51, dwVerMinor = 51; NT 4.0, dwVerMinor= 0.
  dwBuildNumber   As Long         'NT: build number of the OS
                                  'Win9x: build number of the OS in low-order word.
                                  '       High-order word contains major & minor ver nos.
  PlatformID      As Long         'Identifies the operating system platform.
  szCSDVersion    As String * 128 'NT: string, such as "Service Pack 3"
                                  'Win9x: 'arbitrary additional information'
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

'Private Const INVALID_HANDLE_VALUE = -1
Private Const MAX_PATH = 260

'Private Type FILETIME
'    dwLowDateTime As Long
'    dwHighDateTime As Long
'End Type
'
'Private Type WIN32_FIND_DATA
'    dwFileAttributes As Long
'    ftCreationTime As FILETIME
'    ftLastAccessTime As FILETIME
'    ftLastWriteTime As FILETIME
'    nFileSizeHigh As Long
'    nFileSizeLow As Long
'    dwReserved0 As Long
'    dwReserved1 As Long
'    cFileName As String * MAX_PATH
'    cAlternate As String * 14
'End Type

'find file API functions
Private Declare Function SearchTreeForFile Lib "imagehlp.dll" (ByVal sRootPath As String, ByVal InputPathName As String, ByVal OutputPathBuffer As String) As Boolean
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

'enumerate drives API functions
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6

Private Function GetWinDir() As String
    Dim nSize As Long
    Dim tmp As String
    tmp = Space$(256)
    nSize = Len(tmp)
    Call GetWindowsDirectory(tmp, nSize)
    GetWinDir = Trim(tmp)
End Function

Private Function IsWin95() As Boolean
    Dim OSV As OSVERSIONINFO
    OSV.OSVSize = Len(OSV)
    If GetVersionEx(OSV) = 1 Then 'PlatformId contains a value representing the OS.
         IsWin95 = (OSV.PlatformID = VER_PLATFORM_WIN32_WINDOWS) And _
                   (OSV.dwVerMajor = 4 And OSV.dwVerMinor = 0)
    End If
End Function

Private Function IsWin98() As Boolean
    Dim OSV As OSVERSIONINFO
    OSV.OSVSize = Len(OSV)
    If GetVersionEx(OSV) = 1 Then 'PlatformId contains a value representing the OS.
         IsWin98 = (OSV.PlatformID = VER_PLATFORM_WIN32_WINDOWS) And _
                   (OSV.dwVerMajor > 4) Or _
                   (OSV.dwVerMajor = 4 And OSV.dwVerMinor > 0)
    End If
End Function

Private Function IsWinNT() As Boolean
    Dim OSV As OSVERSIONINFO
    OSV.OSVSize = Len(OSV)
    If GetVersionEx(OSV) = 1 Then 'PlatformId contains a value representing the OS.
         IsWinNT = (OSV.PlatformID = VER_PLATFORM_WIN32_NT)
    End If
End Function

Private Function GetFileLocation(sDrive2Scan As String, sFile2Find As String) As String
    Dim sResult As String
    sResult = Space(MAX_PATH)
    
    If SearchTreeForFile(sDrive2Scan, sFile2Find, sResult) Then
        GetFileLocation = Left(sResult, InStr(sResult, vbNullChar) - 1)
    End If
End Function

Private Function FindOtherHardDrive() As String
    Dim i%, allDrives$, curDrive$, drvType$
    
    'get the list of all available drives
    allDrives$ = Space$(64)
    Call GetLogicalDriveStrings(Len(allDrives$), allDrives$)
    allDrives$ = Trim$(allDrives$)
    
    i% = 1
    While InStr(i%, allDrives$, Chr$(0)) > 0 'get the drive type
        curDrive$ = Mid$(allDrives$, i%, InStr(i%, allDrives$, Chr$(0)) - i%)
        drvType$ = rgbDrvType(curDrive$)
        i% = InStr(i%, allDrives$, Chr$(0)) + 1
        If drvType$ = "Hard drive" Then
            If LCase$(curDrive$) <> LCase$(Left$(GetWinDir, InStr(3, GetWinDir, "\"))) Then
                FindOtherHardDrive = curDrive$
                Exit Function
            End If
        End If
    Wend
End Function

Private Function rgbDrvType(RootPathName) As String
    'Passed is the drive to check. Returned is the type of drive.
     Dim r As Long
     r = GetDriveType(RootPathName)
     Select Case r
        Case 0: rgbDrvType = "Cannot be determined"
        Case 1: rgbDrvType = "Does not exist"
        Case DRIVE_REMOVABLE:
            Select Case LCase$(Left$(RootPathName, 1))
                Case "a", "b": rgbDrvType = "Floppy drive"
                Case Else: rgbDrvType = "Removable drive"
            End Select
        Case DRIVE_FIXED:   rgbDrvType = "Hard drive"
        Case DRIVE_REMOTE:  rgbDrvType = "Network drive"
        Case DRIVE_CDROM:   rgbDrvType = "CD-ROM drive"
        Case DRIVE_RAMDISK: rgbDrvType = "RAM disk"
    End Select
End Function

Private Sub cmdCompare_Click()
    If optProgram(0).Value = True Then
        If IsWinNT Then
            On Error Resume Next
            Shell "cmd /k fc /c " & Chr$(34) & frmCheckInOut.txtLocalDir & lstConflicts & Chr$(34) & " " & Chr$(34) & frmCheckInOut.txtNetDir & lstConflicts & Chr$(34) & " | more", vbNormalFocus
            If Err <> 0 Then
                MsgBox "Error: could not run 'cmd /k fc'."
            End If
            On Error GoTo 0
        Else
            Dim f%
            Dim cmdln$
            cmdln$ = "fc /c " & Chr$(34) & frmCheckInOut.txtLocalDir & lstConflicts & Chr$(34) & " " & Chr$(34) & frmCheckInOut.txtNetDir & lstConflicts & Chr$(34) & " | more"
            f% = FreeFile
            Open App.path & "\vbtmp.bat" For Output As #f%
            Print #f%, cmdln$
            Close #f%
            On Error Resume Next
            Shell App.path & "\vbtmp.bat", vbNormalFocus
            If Err <> 0 Then
                MsgBox "Error: could not run 'fc' via temp .bat file."
            End If
            On Error GoTo 0
        End If
    Else
        On Error Resume Next
        Shell "windiff " & Chr$(34) & frmCheckInOut.txtLocalDir & lstConflicts & Chr$(34) & " " & Chr$(34) & frmCheckInOut.txtNetDir & lstConflicts & Chr$(34)
        If Err <> 0 Then
            Err.Clear
            MousePointer = vbHourglass
            On Error GoTo 0
            Dim windiffpath$
            windiffpath$ = GetFileLocation(Left$(GetWinDir, InStr(3, GetWinDir, "\")), "windiff.exe")
            If windiffpath$ = "" Then
                If Left$(GetWinDir, InStr(3, GetWinDir, "\")) <> Left$(App.path, InStr(3, App.path, "\")) Then
                    windiffpath$ = GetFileLocation(Left$(App.path, InStr(3, App.path, "\")), "windiff.exe")
                End If
            End If
            If windiffpath$ = "" Then
                If FindOtherHardDrive <> "" Then
                    windiffpath$ = GetFileLocation(FindOtherHardDrive, "windiff.exe")
                End If
            End If
            If windiffpath$ <> "" Then
                Err.Clear
                On Error Resume Next
                Shell windiffpath$ & " " & Chr$(34) & frmCheckInOut.txtLocalDir & lstConflicts & Chr$(34) & " " & Chr$(34) & frmCheckInOut.txtNetDir & lstConflicts & Chr$(34)
                If Err <> 0 Then
                    MsgBox "Error: WinDiff may not be installed."
                End If
            Else
                MsgBox "Error: WinDiff may not be installed."
            End If
            MousePointer = vbDefault
        End If
        On Error GoTo 0
    End If
End Sub

Private Sub cmdDelete_Click()
    Dim response%
    response% = MsgBox("Delete from network? (Click 'No' to delete local)", vbYesNoCancel + vbDefaultButton3)
    If response% = vbYes Then
        If MsgBox("Are you sure you want to delete the network file: " & frmCheckInOut.txtNetDir & lstConflicts & "?", vbYesNo + vbDefaultButton2) = vbYes Then
            On Error Resume Next
            Kill frmCheckInOut.txtNetDir & lstConflicts
            If Err <> 0 Then
                MsgBox "Could not delete file."
            End If
            On Error GoTo 0
        End If
    ElseIf response% = vbNo Then
        If MsgBox("Are you sure you want to delete the local file: " & frmCheckInOut.txtLocalDir & lstConflicts & "?", vbYesNo + vbDefaultButton2) = vbYes Then
            On Error Resume Next
            Kill frmCheckInOut.txtLocalDir & lstConflicts
            If Err <> 0 Then
                MsgBox "Could not delete file."
            End If
            On Error GoTo 0
        End If
    End If
End Sub

Private Sub cmdEdit_Click()
    Shell "notepad " & Chr$(34) & frmCheckInOut.txtLocalDir & lstConflicts & Chr$(34), vbNormalFocus
    Shell "notepad " & Chr$(34) & frmCheckInOut.txtNetDir & lstConflicts & Chr$(34), vbNormalFocus
End Sub

Private Sub Form_Load()
    Dim oneitem$
    Dim start%
    lstConflicts.Clear
    start% = 1
    While InStr(start%, frmCheckInOut.ConflictMsg$, vbCrLf) > 0
        If oneitem$ <> "" Then
            If Left$(oneitem$, InStr(oneitem$, vbCrLf) - 1) <> "" Then
                lstConflicts.AddItem Left$(oneitem$, InStr(oneitem$, vbCrLf) - 1)
            End If
            oneitem$ = ""
        End If
        oneitem$ = Mid$(frmCheckInOut.ConflictMsg$, InStr(start%, frmCheckInOut.ConflictMsg$, vbCrLf) + 2)
        start% = InStr(start%, frmCheckInOut.ConflictMsg$, vbCrLf) + 1
    Wend
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Dir$(App.path & "\vbtmp.bat") <> "" Then
        Kill App.path & "\vbtmp.bat"
    End If
    frmCheckInOut.Show
End Sub

Private Sub lstConflicts_Click()
    cmdCompare.Enabled = True
    cmdEdit.Enabled = True
    cmdDelete.Enabled = True
End Sub

