VERSION 5.00
Begin VB.Form frmHelp 
   Caption         =   "Help"
   ClientHeight    =   1995
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1995
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cmbTopic 
      Height          =   315
      ItemData        =   "Help.frx":0000
      Left            =   1200
      List            =   "Help.frx":001F
      Style           =   2  'Dropdown List
      TabIndex        =   1
      ToolTipText     =   "Topic choices"
      Top             =   48
      Width           =   3375
   End
   Begin VB.TextBox txtHelp 
      BackColor       =   &H8000000B&
      Height          =   1335
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   480
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "Topic:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmHelp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmbTopic_Click()
    txtHelp = ""
    If cmbTopic = "Why Use This Program?:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Why Use This Program?:" & vbCrLf
        txtHelp = txtHelp & "This program helps prevent overwriting other people's code when programming in a multiple developer project.  "
        txtHelp = txtHelp & "It is a passive protection and is not near as powerful as a program like source-safe.  "
        txtHelp = txtHelp & "However, it also is less restrictive than a tool like that and is way better than trying to manually synchronize files." & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Initial Configuration:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Initial Configuration:" & vbCrLf
        txtHelp = txtHelp & "Copy all files to the network directory.  Select source code directories by clicking the "
        txtHelp = txtHelp & "'Local Directory:' and 'Net Directory:' buttons.  Then click the 'Update Files' button." & vbCrLf & vbCrLf
        txtHelp = txtHelp & "A file 'checkout_<user>.lst' will be stored one directory up from the network directory.  "
        txtHelp = txtHelp & "(If you want the file stored elsewhere, you can change it in the options screen.)" & vbCrLf & vbCrLf
        txtHelp = txtHelp & "The user name is taken from the current windows logon user." & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Program Use:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Program Use:" & vbCrLf
        txtHelp = txtHelp & "Click the 'Help' button to display this window.  Click the 'Check Files' button to see what files the program thinks need to be updated.  Click the 'Update Files' button to actually copy files that need to be updated.  "
        txtHelp = txtHelp & "(It will show files that will be copied and allow you to cancel the action before proceeding.)" & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "If 'Automatically check for files changes' is checked, it will pop up a reminder window every [?] minutes (as specified) if any files need to be updated." & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "Clicking the Mail icon button allows you to send a message using the NT's DOS command 'net send'.  Windows users with a 'checkout_<user>.lst' file (in the same directory as you file) appear in the drop down." & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "Clicking the Hammer icon button brings up the options screen to set program configuration options." & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "In the Options screen, the 'Check files every [_] minutes' field sets how long before automatically checking for new files." & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "If 'Ignore Conflict files with extension(s)' is checked, the program won't try to updated files with that extension if they conflict.  To enter multiple extensions, seperate values with a comma.  "
        txtHelp = txtHelp & "(In Visual Basic, the '.vbw' file is a good example.  It always changes and only has user settings.)" & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "The 'Location of Checkout List File:' radio buttons specify where the 'checkout_<user>.lst' file should be stored.  The default is 'Net Directory\..' "
        txtHelp = txtHelp & "(which is the folder above the network source code directory).  Click 'App Directory' if you would rather have it stored in the directory with this utility.  "
        txtHelp = txtHelp & "Click 'Custom [...]' to choose a different directory.  (Note:  The 'checkout_<user>.lst' should not be in the same directory as source code.  "
        txtHelp = txtHelp & "If all users' files aren't in the same place, the 'Send Message' window won't automatically find the other developer names.)" & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "Clicking the Eye icon button brings up the Resolve Conflicts screen to compare/edit/delete files that conflict." & vbCrLf & vbCrLf
        
        txtHelp = txtHelp & "In the Resolve Conflicts screen, click the 'Compare' button to show differences in the files.  "
        txtHelp = txtHelp & "(The 'Compare with' radio buttons determine which program to compare the files with, the DOS 'fc.exe' program or 'windiff.exe'.  "
        txtHelp = txtHelp & "Click edit to open the source files in an editor.  Click delete to delete one of the files." & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Program Logic:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Program Logic:" & vbCrLf
        txtHelp = txtHelp & "File dates in your local directory are compared to the file date of the file you last copied.  "
        txtHelp = txtHelp & "If the file date is the same, but the network file date is newer, it assumes you need the new file on the network.  "
        txtHelp = txtHelp & "If the file date is newer, and the network file date is the same, it assumes you need to update the network file.  "
        txtHelp = txtHelp & "If the file date is newer, but the network file date is also newer, it assumes that there is a conflict in changes.  " & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Resolving Conflicts:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Resolving Conflicts:" & vbCrLf
        txtHelp = txtHelp & "You can compare files to see if they are different by using the DOS command 'fc', a program like 'Windiff', or by manually viewing the souce code side by side.  "
        txtHelp = txtHelp & "If you know the files are the same, you may delete the local or network file and then do an update.  "
        txtHelp = txtHelp & "If the files are different, manually merge/fix one file and then delete the other file and then do an update." & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Warnings:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Warnings:" & vbCrLf
        txtHelp = txtHelp & "This program isn't 100% reliable.  Make backups often.  "
        txtHelp = txtHelp & "The program doesn't copy files in sub-directories.  "
        txtHelp = txtHelp & "The more often you 'Update' the less conflicts you will have.  "
        txtHelp = txtHelp & "Don't have the files open when updating your local files or they may be written back from the 'cached' versions which would replace the new files.  "
        txtHelp = txtHelp & "Don't modify the files directly from the Network directory.  If the file is open and someone updates the files, they may be write back from the 'cached' versions when it saves which would replace the new files.  "
        txtHelp = txtHelp & "Copying and deleting files without using this program can obviously cause problems as the 'checkout_<user>.lst' file isn't updated." & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Version:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Version:" & vbCrLf
        txtHelp = txtHelp & "1.0.0 - Initial Release - Sept. 16, 1999" & vbCrLf & vbCrLf
    End If
    If cmbTopic = "Author:" Or cmbTopic = "All Topics:" Then
        txtHelp = txtHelp & "Author:" & vbCrLf
        txtHelp = txtHelp & "This program was created and designed by Andy Pearson (email: apearson@bigfoot.com).  The program and code is free for use (to change, modify, or copy).  I make no guarantees.  Use at your own risk.  If you have questions and I am not too busy, I may answer them.  "
        txtHelp = txtHelp & "If you make changes to improve it, please let me know so I can also benefit.  Enjoy!"
    End If
End Sub

Private Sub Form_Load()
    If cmbTopic = "" Then
        cmbTopic = "All Topics:"
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    frmCheckInOut.Show
End Sub

