VERSION 5.00
Begin VB.Form frmOptions 
   Caption         =   "Options"
   ClientHeight    =   1995
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1995
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraChkLstDir 
      Caption         =   "Location of Checkout List File:"
      Height          =   615
      Left            =   120
      TabIndex        =   5
      Top             =   960
      Width           =   4455
      Begin VB.OptionButton optChkLstDir 
         Caption         =   "Custom [...]"
         Height          =   255
         Index           =   2
         Left            =   3000
         TabIndex        =   8
         ToolTipText     =   "Select custom directory"
         Top             =   240
         Width           =   1335
      End
      Begin VB.OptionButton optChkLstDir 
         Caption         =   "App Directory"
         Height          =   255
         Index           =   1
         Left            =   1560
         TabIndex        =   7
         ToolTipText     =   "Directory where .EXE resides"
         Top             =   240
         Width           =   1335
      End
      Begin VB.OptionButton optChkLstDir 
         Caption         =   "Net Directory\.."
         Height          =   255
         Index           =   0
         Left            =   40
         TabIndex        =   6
         ToolTipText     =   "Directory above network source directory"
         Top             =   240
         Width           =   1590
      End
   End
   Begin VB.TextBox txtExtension 
      Height          =   315
      Left            =   3360
      TabIndex        =   4
      Text            =   ".vbw"
      ToolTipText     =   "File extensions to ignore  (ex. '.vbw,.log')"
      Top             =   480
      Width           =   1215
   End
   Begin VB.CheckBox chkIgnore 
      Caption         =   "Ignore Conflict files with extension(s):"
      Height          =   555
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "Specifies certain file extension(s) should not be reported if they conflict."
      Top             =   360
      Value           =   1  'Checked
      Width           =   3075
   End
   Begin VB.TextBox txtMinutes 
      Height          =   315
      Left            =   1680
      TabIndex        =   0
      Text            =   "15"
      ToolTipText     =   "Number of minutes to wait"
      Top             =   48
      Width           =   555
   End
   Begin VB.Label Label3 
      Caption         =   "minutes"
      Height          =   195
      Left            =   2400
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Check files every"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "frmOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim blnRunOptClick As Boolean

Private Sub chkIgnore_Click()
    frmCheckInOut.blnIgnoreExt = chkIgnore
End Sub

Private Sub Form_Load()
    txtMinutes = frmCheckInOut.Minutes%
    chkIgnore = Abs(frmCheckInOut.blnIgnoreExt)
    txtExtension = frmCheckInOut.Extension$
    blnRunOptClick = False
    Select Case frmCheckInOut.ChkLstFileDir$
    Case "<NetDir>\.."
        optChkLstDir(0).Value = True
    Case "<AppDir>"
        optChkLstDir(1).Value = True
    Case Else
        optChkLstDir(2).Value = True
    End Select
    blnRunOptClick = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    frmCheckInOut.Show
End Sub

Private Sub optChkLstDir_Click(Index As Integer)
    If Not blnRunOptClick Then Exit Sub
    Select Case Index
    Case 0
        frmCheckInOut.ChkLstFileDir$ = "<NetDir>\.."
    Case 1
        frmCheckInOut.ChkLstFileDir$ = "<AppDir>"
    Case 2
        frmCheckInOut.ChkLstFileDir$ = frmCheckInOut.GetDirectory & "\"
        If Right$(frmCheckInOut.ChkLstFileDir$, 2) = "\\" Then
            frmCheckInOut.ChkLstFileDir$ = Left$(frmCheckInOut.ChkLstFileDir$, Len(frmCheckInOut.ChkLstFileDir$) - 1)
        End If
    End Select
End Sub

Private Sub txtExtension_Change()
    frmCheckInOut.Extension$ = txtExtension
End Sub

Private Sub txtMinutes_Change()
    Static InChange As Boolean
    If Not InChange Then
        InChange = True
        txtMinutes = Val(txtMinutes)
        If Val(txtMinutes) < 1 Then
            txtMinutes = 1
        End If
        InChange = False
        frmCheckInOut.Minutes% = txtMinutes
    End If
End Sub
